/*
 * asmatch.h,v 1.1 1993/12/23 03:11:06 jch Exp
 */

/*%Copyright%*/


#define	ASP_WORD	(sizeof(flag_t) * NBBY)		/* bytes in a word */
#define	ASP_BITS	30				/* max state #, beginning from 0 */
#define	ASP_ACC		(ASP_BITS + 1)			/* accept state */

typedef	struct {
    as_t	as;
    flag_t	next[1 + ASP_ACC / ASP_WORD];
} asp_table;

typedef	struct {
    flag_t	origin_mask;
    flag_t	start[1 + ASP_ACC / ASP_WORD];
    asp_table	nfa[ASP_ACC];
} asmatch_t;

extern block_t aspath_match_index;

#define	NFA_ZERO(x)		{ \
	register int macvar = ASP_ACC / ASP_WORD; \
	do { \
	    x[macvar] = 0; \
	} while (macvar--) ; \
    }
#define	NFA_ASG(x, y)	{ \
    	register int macvar = ASP_ACC / ASP_WORD; \
	do { \
	    x[macvar] = y[macvar]; \
	} while (macvar--) ; \
    }
#define	NFA_OR(x, y, z)	{ \
    	register int macvar = ASP_ACC / ASP_WORD; \
	do { \
	    x[macvar] = y[macvar] | z[macvar]; \
	} while (macvar--) ; \
    }
#define	NFA_AND(x,y,z)	{ \
    	register int macvar = ASP_ACC / ASP_WORD; \
	do { \
	    x[macvar] = y[macvar] & z[macvar]; \
	} while (macvar--) ; \
    }
#define	NFA_NONZERO(x, i)	{ \
    	register int macvar = ASP_ACC / ASP_WORD; \
	i = FALSE; \
	do { \
	    if (x[macvar]) { \
		i = TRUE; \
		break; \
	    } \
	} while (macvar--) ; \
    }
#define	NFA_SET(x,y)	(x[(y) / ASP_WORD] |= (1 << ((y) % ASP_WORD)))
#define	NFA_CLR(x,y)	(x[(y) / ASP_WORD] &= ~(1 << ((y) % ASP_WORD)))
#define	NFA_ISSET(x,y)	(x[(y) / ASP_WORD] & (1 << ((y) % ASP_WORD)))

#define	NFA_SHIFT(x,y)	{ \
	register int macvar; \
	if (NFA_ISSET(x, ASP_ACC)) { \
	    NFA_SET(x, ASP_ACC- ((y) % ASP_ACC)); \
	} \
	for (macvar= ASP_ACC / ASP_WORD; macvar>(y) / ASP_WORD; macvar--) { \
	    x[macvar] = x[macvar-(y) / ASP_WORD]<<((y) % ASP_WORD); \
	    x[macvar]|=(x[macvar-1-(y) / ASP_WORD]>>(ASP_WORD - ((y) % ASP_WORD))); \
	} \
	x[macvar] = x[0]<<((y) % ASP_WORD); \
	while (macvar--) { \
            x[macvar] = 0; \
	} \
	x[ASP_ACC / ASP_WORD] <<= (ASP_WORD - 1 - ASP_ACC % ASP_WORD); \
	x[ASP_ACC / ASP_WORD] >>= (ASP_WORD - 1 - ASP_ACC % ASP_WORD); \
    }

struct _asp_range {
  u_short begin;
  u_short end;
};

typedef struct _asp_range asp_range;

struct _asp_stack {
  flag_t start[1 + ASP_ACC/ASP_WORD];
  flag_t state[1 + ASP_ACC/ASP_WORD];
};

typedef struct _asp_stack asp_stack;


/* Routines to handle control information */
PROTOTYPE(aspath_adv_match,
	  extern int,
	  (void_t,
	   as_path *));
PROTOTYPE(aspath_adv_compare,
	  extern int,
	  (void_t,
	   void_t));
PROTOTYPE(aspath_adv_print,
	  extern char *,
	  (void_t));
PROTOTYPE(aspath_adv_free,
	  extern void,
	  (void_t));
PROTOTYPE(aspath_adv_origins,
	  extern char *,
	  (flag_t));


PROTOTYPE(aspath_init_regex,
	  void,
	  (void));
PROTOTYPE(aspath_consume_current,
	  asmatch_t *,
	  (void));
PROTOTYPE(aspath_simple_regex,
	  void,
	  (asp_stack *,
	   asp_stack *));
PROTOTYPE(aspath_copy_regex,
	  void,
	  (asp_stack *,
	   asp_stack *));
PROTOTYPE(aspath_merge_regex,
	  void,
	  (asp_stack *,
	   asp_stack *,
	   asp_stack *));
PROTOTYPE(aspath_prepend_regex,
	  int,
	  (asp_stack *,
	   asp_stack *,
	   asp_stack *));
PROTOTYPE(aspath_zero_or_more_term,
	  void,
	  (asp_stack *,
	   asp_stack *));
PROTOTYPE(aspath_one_or_more_term,
	  void,
	  (asp_stack *,
	   asp_stack *));
PROTOTYPE(aspath_zero_or_one_term,
	  void,
	  (asp_stack *,
	   asp_stack *));
PROTOTYPE(aspath_range_term,
	  int,
	  (asp_stack *,
	   asp_stack *,
	   asp_range *));
PROTOTYPE(aspath_as_transition,
	  int,
	  (asp_stack *,
	   int));
PROTOTYPE(aspath_any_transition,
	  int,
	  (asp_stack *));
