/* Heu, bon, on va essayer :-)
 */
/* Remark: WRIE() and WRITEF() delete the job task and the receive task
 * if an error occurs. Be carefull.
 */
#include "include.h"
#include "rt_var.h"
#include "inet.h"
#include "port.h"

#define NDEBUG

/*
 *
 */
trace *port_default_trace_options = NULL;
const bits port_trace_types[] = {
	{ TR_DETAIL,        "detail packets" },
	{ TR_DETAIL_SEND,   "detail send packets" },
	{ TR_DETAIL_RECV,   "detail recv packets" },
	{ TR_PACKET,        "packets" },
	{ TR_PACKET_SEND,   "send packets" },
	{ TR_PACKET_RECV,   "recv packets" },
	{ TR_DETAIL_1,      "detail redirect" },
	{ TR_DETAIL_SEND_1, "detail send redirect" },
	{ TR_DETAIL_RECV_1, "detail recv redirect" },
	{ TR_PACKET_1,      "redirect" },
	{ TR_PACKET_SEND_1, "send redirect" },
	{ TR_PACKET_RECV_1, "recv redirect" },
	{ TR_DETAIL_2,      "detail router" },
	{ TR_DETAIL_SEND_2, "detail send router" },
	{ TR_DETAIL_RECV_2, "detail recv router" },
	{ TR_PACKET_2,      "router" },
	{ TR_PACKET_SEND_2, "send router" },
	{ TR_PACKET_RECV_2, "recv router" },
	{ TR_DETAIL_3,      "detail info" },
	{ TR_DETAIL_SEND_3, "detail send info" },
	{ TR_DETAIL_RECV_3, "detail recv info" },
	{ TR_PACKET_3,      "info" },
	{ TR_PACKET_SEND_3, "send info" },
	{ TR_PACKET_RECV_3, "recv info" },
	{ TR_DETAIL_4,      "detail error" },
	{ TR_DETAIL_SEND_4, "detail send error" },
	{ TR_DETAIL_RECV_4, "detail recv error" },
	{ TR_PACKET_4,      "error" },
	{ TR_PACKET_SEND_4, "send error" },
	{ TR_PACKET_RECV_4, "recv error" },
	{ 0, NULL }
};

void (*port_task_terminate)() =
	(void (*)())task_delete;
void (*port_recv_term)() =
	(void (*)())task_delete;
task *port_task_listen = (task *)NULL;

static char global_static_write_buff[BUFSIZ]; /* Used by WRITEF() */
block_t port_job_data_index;

/* To be called AFTER the config parse
 */
void
port_init()
{
	int s;

	trace_tf(trace_global, TR_NORMAL, 0,
		("port_init: initialising port_task_listen (%p)\n",
		port_task_listen));

	/* port_var_init is call at the beginig and when reconfiguring
	 */
	if (port_task_listen)
		return;

	/* Alloc stuff
	 */
	port_job_data_index = task_block_init(sizeof(port_job_data), 
		"port_job_data");

	/* Initialise some stuff for tracing???
	 */
	trace_inherit_global(port_default_trace_options,
		port_trace_types, (flag_t)0);

	/* Allocate the task
	 */
	port_task_listen = task_alloc(PORT_TASK_NAME,
			TASKPRI_NETMGMT, /* Why not? */
			port_default_trace_options);

	/* Fill some stuff...
	 */
	port_task_listen->task_rtproto = RTPROTO_BGP; /* ???? */
	task_set_terminate(port_task_listen, port_task_terminate);
	task_set_dump(port_task_listen, port_task_dump);
	port_task_listen->task_data = (void_t)NULL;	/* No dat associated */
	BIT_SET(port_task_listen->task_flags, TASKF_LOWPRIO);

	/* Create the fucking task!
	 */
	if (!task_create(port_task_listen)) {
		task_quit(EINVAL);
	}

	/* Get a socket. C.f. BGP bgp_listen_start() code :-)
	 */
	if ((s = task_get_socket(port_task_listen, AF_INET, SOCK_STREAM, 0))
		< 0) {
		s = errno;
		trace_log_tp(port_task_listen, 0, LOG_ERR,
                     ("port_var_init: couldn't get PORT listen socket!!"));
        	task_quit(s);
	}
	
	trace_log_tp(port_task_listen, 1, LOG_ERR,
		("port_init: got socket %d\n", s));
		/* Usefull? BIT_SET(TASKF_ACCEPT) in task_set_socket() */
	port_task_listen->task_flags |= TASKF_ACCEPT;
	port_task_listen->task_addr = sockdup(inet_addr_any);
	sock2port(port_task_listen->task_addr) = htons(PORT_DEFAULT_PORT);
		/* Usefull? Called in task_set_socket() */
	task_set_accept(port_task_listen, port_listen_accept);
	task_set_socket(port_task_listen, s);

	if (task_set_option(port_task_listen, TASKOPTION_REUSEADDR, TRUE) < 0) {
		task_quit(errno);
	}
	if (task_addr_local(port_task_listen, port_task_listen->task_addr)) {
		task_quit(errno);
	}
	if (listen(s, 5) < 0) {
		trace_log_tp(port_task_listen, 0, LOG_ERR,
			("port_listen_start: listen: %m"));
		task_quit(errno);
	}
}


/* Method for dump the listening task
 */
/*ARGSUSED*/
void
port_task_dump(tp, fd)
	task *tp;
	FILE *fd;
{
	(void)fprintf(fd, "Hello world :-)\n");
}

/* Dump receiving task
 */
/*ARGSUSED*/
void
port_recv_dump(tp, fd)
	task *tp;
	FILE *fd;
{
	(void)fprintf(fd, "This is the receiving task!!!\n");
}

/* Method when accepting a connection
 */
void
port_listen_accept(listen_tp)
	task *listen_tp;
{
	struct sockaddr_in inaddr;
	size_t inaddrlen;
	int s;
	sockaddr_un *peeraddr;
	task *tp;

	/*
	 * Accept the connection
	 */
	inaddrlen = sizeof(inaddr);
	if ((s = accept(listen_tp->task_socket, (struct sockaddr *) &inaddr,
			(int *) &inaddrlen)) < 0) {
		trace_log_tp(listen_tp, 0, LOG_ERR,
			("port_listen_accept: accept(%d): %m",
			listen_tp->task_socket));
		return;
	}

	peeraddr = sockdup(sock2gated((struct sockaddr *) &inaddr, inaddrlen));
	trace_tp(listen_tp, TR_NORMAL, 0,
		("port_listen_accept: accepting connection from %#A\n",
		peeraddr));

	/* Create the receiving task. C.f. bgp_listen_accept()
	 */
	tp = task_alloc("PORT_receive", TASKPRI_EXTPROTO,
		port_default_trace_options);
	BIT_SET(tp->task_flags, TASKF_LOWPRIO);
	tp->task_socket = s;
	tp->task_addr = peeraddr;
	tp->task_rtproto = RTPROTO_BGP;
	tp->task_data = (void_t)NULL;	/* Gonna point to the task job */
	task_set_recv(tp, port_recv);
	task_set_dump(tp, port_recv_dump);
	task_set_terminate(tp, port_recv_term);
	if (!task_create(tp)) {
		task_quit(EINVAL);
	}
}

/* method for the receiving task
 */
void
port_recv(tp_recv)
	task *tp_recv;
{
	int len_read;
	char blakhole[10];	/* **** :-( */
	flag_t type = 0;
	task_job *tjp;

	/* read something, (bgp_recv())
	 */
	len_read = read(tp_recv->task_socket, blakhole, 1);

	if (len_read < 0) {
		switch (errno) {
		case EWOULDBLOCK:
#if	 defined(EAGAIN) && EAGAIN != EWOULDBLOCK
		case EAGAIN:
#endif  /* EAGAIN */
		case EINTR:
			return;

		case ENETUNREACH:
		case EHOSTUNREACH:
			trace_tp(tp_recv, TR_ALL, 0, ("port_recv: %m"));
			return;

		default:
			trace_log_tp(tp_recv, 0, LOG_ERR,
				("port_recv: read failed: %m"));
			tjp = (task_job *)tp_recv->task_data;
			port_term_job(tjp);
			task_delete(tp_recv);
			return;
		}
	} else if (len_read == 0) {
		trace_log_tp(tp_recv, 0, LOG_ERR,
			("port_recv: Peer %#A disconnected without advice!",
			tp_recv->task_addr));
		tjp = (task_job *)tp_recv->task_data;
		port_term_job(tjp);
		task_delete(tp_recv);
		return;
	}

	/* My very simple protocole: if we recive ' ' (space), dump in
	 * ascii. If we receive '1' :) dump in binary, if we receive '\0'
	 * close the connection, else we don't care.
	 */
	switch(blakhole[0]) {
	case PT_DUMPASCII:
		BIT_SET(type, REQ_ASCII);
		BIT_SET(type, REQ_DUMP);
		break;	
	case PT_DUMPBIN:	
		BIT_SET(type, REQ_DUMP);
		break;
	case PT_EOF:
		tjp = (task_job *)tp_recv->task_data;
		port_term_job(tjp);
		trace_log_tp(tp_recv, 0, LOG_ERR,
			("PT_EOF received: disconnecting from %#A",
				tp_recv->task_addr));
		task_delete(tp_recv);
		return;
	default: /* Who cares !!!! */
		break;
	}

	if (!BIT_TEST(type, REQ_DUMP))
		return;

	/* Small intro for the ascii dump
	 */
	if (BIT_TEST(type, REQ_ASCII))
		WRITEF((BUFF, "Stating dump of the routing table\n"), tp_recv);
	
	/* dump if not busy...
	 */
	if (!tp_recv->task_data)
		port_bg_rt_dump(tp_recv, type);
}

/* Dump the routing table by creating a bg job
 */
void
port_bg_rt_dump(tp_recv, type)
	task *tp_recv;
	flag_t type;
{
	task_job *tjp;
 	port_job_data *pjd;

	/* rt_dump(rt_task, fdump) */
	/* Get the first route from the RT
	 */

	pjd = (port_job_data *)task_block_alloc(port_job_data_index);
	pjd->rth = rt_radix_first(pjd);
	pjd->count = 0;
	pjd->req_type = type;

	if (pjd->rth) {

		/* Lock the route
		 */
		pjd->rth->rth_references++;

		/* Create a bg job which write 1 route per run.
                 * This job will destroy itself when done (i hope :-)
		 * The associated data is a port_job_data *pointer
                 */
                tjp = task_job_create(port_task_listen, TASK_JOB_PRIO_WORST,
                        "PORT_dumping_job", port_dump_job, (void_t)pjd);
                trace_tp(port_task_listen, TR_NORMAL, 0,
                        ("port_bg_rt_dump: job created\n"));
		tp_recv->task_data = (void_t)tjp;
		pjd->tp_recv = tp_recv;
	}
	else {
		/* Free pjd
		 */
		task_block_free(port_job_data_index, (caddr_t)pjd);

		/* Send warning
		 */
		if (BIT_TEST(type, REQ_ASCII)) {
			WRITEF((BUFF, "No route to print!!!\n"), tp_recv);
		}
		else {
			/* ends the dump */
			BUFF[0] = PT_ENDDUMP;
			WRITE(BUFF, 1, tp_recv);
		}
	}
}

/* Job in BG to read the RT
 */
void
port_dump_job(tjp)
	task_job *tjp;
{
	task *tp_recv;
 	port_job_data *pjd;
	rt_head *rth;

	pjd = (port_job_data *)tjp->task_job_data;
	tp_recv = pjd->tp_recv;

	/* Unlock the current route
	 */
	pjd->rth->rth_references--;

	trace_tp(port_task_listen, TR_NORMAL, 0,
		("port_dump_job: couting...\n"));
	if (BIT_TEST(pjd->req_type, REQ_ASCII))
		WRITEF((BUFF, "counter: %d\n", pjd->count), tp_recv);
	if (!tp_recv)		/* We got a write() error */
		return;

	/* Print the route & paths
	 */
	port_dump_rth(&tp_recv, pjd->rth, pjd->req_type);
	if (!tp_recv)           /* We got a write() error */
		return;

	/* Get next entry
	 */
	if (!(pjd->rth = rt_radix_next(pjd))) {
		/* Remove: the job, the connection, the list
		 */
		if (BIT_TEST(pjd->req_type, REQ_ASCII)) {
			WRITEF((BUFF, "\nEnd of dumping.\n"), tp_recv);
		}
		else {
                        /* ends the dump */
                        BUFF[0] = PT_ENDDUMP;
                        WRITE(BUFF, 1, tp_recv);
                }
		port_term_job(tjp);
		return;
	}
	/* Security  against loops */
	pjd->count++;
	if (pjd->count == 30000) {
		if (BIT_TEST(pjd->req_type, REQ_ASCII)) {
			WRITEF((BUFF, "\nLoop detected.End of dumping.\n"),
				tp_recv);
		}
		else {
			BUFF[0] = PT_ENDDUMP;
			WRITE(BUFF, 1, tp_recv);
		}
		trace_log_tp(port_task_listen, 0, LOG_ERR,
			("port_dump_job: loop detected\n"));
		port_term_job(tjp);
		return;
	}

	/* Lock the rth
	 */
	pjd->rth->rth_references++;

	return;
}

/* terminate a job
 */
void
port_term_job(tjp)
	task_job *tjp;
{
	task *tp_recv;
	port_job_data *pjd;

	if (!tjp)
		return;

	pjd = (port_job_data *)tjp->task_job_data;
	pjd->tp_recv->task_data = (void_t)NULL;

	task_block_free(port_job_data_index, (caddr_t)pjd);
	task_job_delete(tjp);

}

/* dump a single rth to fdump
 */
void
port_dump_rth(tp_recv, rth, req_type)
	task **tp_recv;
	rt_head *rth;
	flag_t req_type;
{
	register rt_entry *rt;
	static int af = 0;
	rt_head_proto rtp;

	/* Info available for the ascii dump
	 */
	if (BIT_TEST(req_type, REQ_ASCII) && (socktype(rth->rth_dest) != af)) {
		af = socktype(rth->rth_dest);

		WRITEF((BUFF, "\n\tRouting table for %s (%d):\n",
		gd_lower(trace_value(task_domain_bits, af)), af), *tp_recv);
		WRITEF((BUFF, "\t\tDestinations: %d\tRoutes: %d\n",
			rtaf_info[af].rtaf_dests,
			rtaf_info[af].rtaf_routes), *tp_recv);
		WRITEF((BUFF,
			 "\t\tHolddown: %d\tDelete: %d\tHidden: %d\n\n",
			rtaf_info[af].rtaf_holddowns,
			rtaf_info[af].rtaf_deletes,
			rtaf_info[af].rtaf_hiddens), *tp_recv);
	}

	if (BIT_TEST(req_type, REQ_ASCII)) {
		WRITEF((BUFF, "\t%-15A", rth->rth_dest), *tp_recv);
		if (!BIT_TEST(rth->rth_state, RTS_GROUP)) {
			WRITEF((BUFF,
			"\tmask %-15A",
			rth->rth_dest_mask), *tp_recv);
		}
		WRITEF((BUFF, "\n\t\t\tentries %d\tannounce %d",
			rth->rth_entries, rth->rth_n_announce), *tp_recv);
		if (rth->rth_state) {
			WRITEF((BUFF, "\tstate <%s>",
				trace_bits(rt_state_bits, rth->rth_state)),
					*tp_recv);
		}
		WRITEF((BUFF, "\t\References: %d\n",
			rth->rth_references), *tp_recv);
	
		/* Now the active route
	 	*/
		if (rt = rth->rth_active) {
			WRITEF((BUFF, "\tNextHop: %-15A",
				rt->rt_routers[rt->rt_gw_sel]), *tp_recv);
			WRITEF((BUFF, "\tAS: %5u",
				(rt->rt_gwp->gw_peer_as)?
						rt->rt_gwp->gw_peer_as:
				rt->rt_gwp->gw_local_as), *tp_recv);
			WRITEF((BUFF, "\tMetric: %d\n",
					rt->rt_metric), *tp_recv);
		}

#ifdef  PROTO_ASPATHS
		/* Dump the AS path...
		 */
		if (rt->rt_aspath)
			port_dump_aspath(tp_recv, rt->rt_aspath,req_type, &rtp);
		if (!*tp_recv)          /* We got a write error */
			return;
#endif  /* PROTO_ASPATHS */

	}
	else {	/*Isn't it ugly :-) ???? */
		bcopy((char *)rth->rth_dest, (char *)&rtp.rtp_dest,
			sizeof(rtp.rtp_dest));
		bcopy((char *)rth->rth_dest_mask, (char *)&rtp.rtp_dest_mask,
			sizeof(rtp.rtp_dest_mask));
		rtp.rtp_entries = rth->rth_entries;
		rtp.rtp_n_announce = rth->rth_n_announce;
		rtp.rtp_state = rth->rth_state;
		if (rt = rth->rth_active) {
			bcopy((char *)rt->rt_routers[rt->rt_gw_sel],
				(char *)&rtp.rtp_nexthop,
				sizeof(rtp.rtp_nexthop));
			rtp.rtp_localas = rt->rt_gwp->gw_local_as;
			rtp.rtp_peeras = rt->rt_gwp->gw_peer_as;
			rtp.rtp_metric = rt->rt_metric;
		}
		else {
                        rtp.rtp_entries = 0; /* forced to NULL */
		}

#ifdef  PROTO_ASPATHS
		/* Dump the AS path...
	 	 */
		if (rt && rt->rt_aspath)
			port_dump_aspath(tp_recv, rt->rt_aspath, req_type,&rtp);
		if (!*tp_recv)		/* We got a write error */
			return;
#endif  /* PROTO_ASPATHS */

/*{ int ff, gg; for(ff = 0; ff < sizeof(rtp);) {
        if ((ff % 20) == 0) printf("\n");
        for(gg = 0; gg < 20; gg++, ff++)
            printf("%02X ", (unsigned int)(((unsigned char *)(&rtp))[ff]));
} printf("\n-- %d\n", sizeof(rtp));fflush(stdout);} */

		WRITE(&rtp, sizeof(rtp), *tp_recv);
	}
}

/* dump the AS path (from aspath_dump() aspath.c)
 */
void
port_dump_aspath(tp_recv, pa, req_type, rtp)
        task **tp_recv;
        as_path *pa;
        flag_t req_type;
	rt_head_proto *rtp;
{
	if (BIT_TEST(req_type, REQ_ASCII)) {
		WRITEF((BUFF, "\t\t\tAS Path: "), *tp_recv);
	}
	else
		rtp->rtp_aspathlen = 0;

	if (pa->path_len) {
		register byte *cp;
		register int i, as;
		register u_short *seg;
		register int nseg;
	
		cp = PATH_PTR(pa);
		seg = PATH_SEG_PTR(pa);
		nseg = pa->path_seg_len/PA4_LEN_SEGMENT;
		while (nseg-- > 0) {
			i = PATH_SEG_LEN(*seg);
			if (PATH_ISSET(*seg)) {
				if (BIT_TEST(req_type, REQ_ASCII)) {
					WRITEF((BUFF, "["), *tp_recv);
				}
			}
			while (i-- > 0) {
				as = (int)(*cp++) << 8;
				as += (int)(*cp++);
				if (BIT_TEST(req_type, REQ_ASCII)) {
					WRITEF((BUFF, "%u%s", as, (i > 0)?
						" ": ""), *tp_recv);
				}
				else {
					rtp->rtp_aspath[rtp->rtp_aspathlen++]
						= (as_t)as;
					if (rtp->rtp_aspathlen >= RTP_MAXAS)
						rtp->rtp_aspathlen=RTP_MAXAS-1;
				}
			}
			if (BIT_TEST(req_type, REQ_ASCII))
				if (PATH_ISSET(*seg)) {
					WRITEF((BUFF, "]"), *tp_recv);
				}
				else {
					WRITEF((BUFF, " "), *tp_recv);
				}
			seg++;
		}
		if (BIT_TEST(req_type, REQ_ASCII))  {
			WRITEF((BUFF, "\n"), *tp_recv);
		}
	}
}


/* ******************** Fast klugde to avoid dealing with the radix tree
 * ******************** May need to be rewriten
 */
/* Get the first non null route in the tree
 */
rt_head *
rt_radix_first(savewalk)
	port_job_data *savewalk;
{
	rt_head *rth;
	int skiprtt = NOSKIPFIRST;
	int skiprth = NOSKIPFIRST;

	/* Get the first route (rth) in the tree
	 */
	savewalk->Xrt_table = rt_table_list; /* Set the first one */
	RT_TABLES_GLOBAL(savewalk->af, savewalk->Xrt_table, skiprtt) {
		savewalk->head = RT_TREETOP(savewalk->af);
		savewalk->Xsp = savewalk->Xstack;
		savewalk->Xrn = savewalk->head;
		if (savewalk->head) {
			RT_WALK_GLOBAL(savewalk->head, rth,
					savewalk->Xstack,
					savewalk->Xsp, savewalk->Xrn, skiprth) {
				return(rth);
			}
			RT_WALK_END_GLOBAL(savewalk->head, rth,
					savewalk->Xstack, savewalk->Xsp,
					savewalk->Xrn, skiprtt);
		}
	}
	RT_TABLES_GLOBAL_END(skiprtt);

	return((rt_head *)NULL);
}

/* Get the next null route in the tree
 */
rt_head *
rt_radix_next(savewalk)
	port_job_data *savewalk;
{
	rt_head *rth;
	int skiprtt = SKIPFIRST;
	int skiprth = SKIPFIRST;

	RT_WALK_GLOBAL(savewalk->head, rth, savewalk->Xstack,
			savewalk->Xsp, savewalk->Xrn, skiprth) {
		return(rth);
	}
	RT_WALK_END_GLOBAL(savewalk->head, rth, savewalk->Xstack,
			savewalk->Xsp, savewalk->Xrn, skiprth);

	skiprth = NOSKIPFIRST; /* We lookup a new tree */

	RT_TABLES_GLOBAL(savewalk->af, savewalk->Xrt_table, skiprtt) {
		savewalk->head = RT_TREETOP(savewalk->af);
		savewalk->Xsp = savewalk->Xstack;
		savewalk->Xrn = savewalk->head;
		if (savewalk->head) {
			RT_WALK_GLOBAL(savewalk->head, rth, savewalk->Xstack,
					savewalk->Xsp, savewalk->Xrn, skiprth) {
				return(rth);
			}
			RT_WALK_END_GLOBAL(savewalk->head, rth,
				savewalk->Xstack, savewalk->Xsp, savewalk->Xrn,
				skiprth);
		}
	}
	RT_TABLES_GLOBAL_END(skiprtt);

	return((rt_head *)NULL);
}
